/*
 *  Copyright (C) 2011  Regents of the University of Michigan
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

//////////////////////////////////////////////////////////////////////////
// This file contains the processing for the executable option "revert"
// which reads an SAM/BAM file and writes a SAM/BAM file with the 
// specified previous values restored if the values are known.

#ifndef __REVERT_H__
#define __REVERT_H__

#include "BamExecutable.h"
#include "SamRecord.h"

class Revert : public BamExecutable
{
public:
    Revert();
    static void revertDescription();
    void description();
    void usage();
    int execute(int argc, char **argv);
private:
    bool updateCigar(SamRecord& samRecord);
    bool updateQual(SamRecord& samRecord);
    bool removeBQ(SamRecord& samRecord);


    bool myKeepTags;
};

#endif
